var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance';

var FixTable = (_temp = _class = function (_Component) {
  _inherits(FixTable, _Component);

  function FixTable() {
    _classCallCheck(this, FixTable);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  FixTable.prototype.componentDidMount = function componentDidMount() {
    if (this.instance) return;
    var onBottomRefresh = this.props.onBottomRefresh;

    this.instance = new Instance(this.$el, {
      onBottomRefresh: onBottomRefresh
    });
  };

  FixTable.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        thead = _props.thead,
        tbody = _props.tbody,
        _props$theadFixed = _props.theadFixed,
        theadFixed = _props$theadFixed === undefined ? true : _props$theadFixed,
        _props$columnFixed = _props.columnFixed,
        columnFixed = _props$columnFixed === undefined ? 0 : _props$columnFixed,
        onBottomRefresh = _props.onBottomRefresh,
        others = _objectWithoutProperties(_props, ['thead', 'tbody', 'theadFixed', 'columnFixed', 'onBottomRefresh']);

    if (!thead || !tbody) return null;
    return React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, others, { className: 'fixtable wrap' + (others.className ? ' ' + others.className : '') }),
      React.createElement(
        'div',
        { className: 'fixtable-scroller' },
        React.createElement(
          'table',
          { className: 'fixtable-scroller-table', cellSpacing: '0' },
          thead,
          tbody
        ),
        onBottomRefresh && React.createElement(
          'div',
          { className: 'fixtable-scroller-bottom' },
          React.createElement('div', { className: 'fixtable-bottom-loading' }),
          React.createElement(
            'div',
            { className: 'fixtable-bottom-caption' },
            '\u6B63\u5728\u52A0\u8F7D...'
          )
        )
      ),
      theadFixed && React.createElement(
        'div',
        { className: 'fixtable-fixed' },
        React.createElement(
          'table',
          { className: 'fixtable-fixed-head', cellSpacing: '0' },
          thead,
          tbody
        )
      ),
      columnFixed && React.createElement(
        'div',
        { className: 'fixtable-fixed' },
        React.createElement(
          'table',
          { className: 'fixtable-fixed-column', cellSpacing: '0' },
          tbody
        )
      )
    );
  };

  return FixTable;
}(Component), _class.defaultProps = {}, _temp);
export { FixTable as default };
FixTable.propTypes = process.env.NODE_ENV !== "production" ? {
  thead: PropTypes.node,
  tbody: PropTypes.node,
  theadFixed: PropTypes.bool,
  columnFixed: PropTypes.number,
  onBottomRefresh: PropTypes.func
} : {};